package net.minecraft.src;

import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.net.URISyntaxException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import net.minecraft.client.Minecraft;

import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

// TODO Update InvEdit
// TODO Update block and item IDs in patch.properties and in post
// TODO Average last few position changes for jumping?
// TODO Add ATV to spawner
// TODO Stop stacking of sentries, give sentries bounding boxes against each other
// TODO Render item as 3D (sentry item)

// TODO Guns still flash on ATV
// TODO Sometimes ATV jumps for no reason

// TODO Molotov will go through walls
// TODO Dispenser stuff

// TODO Player spawners in chunks that have never been loaded won't work

// TODO SdkBaseModMp GUI tick doesn't work
// TODO Nuke isn't set off by fire

// TODO Oil duplicates the bucket
// TODO Flamethrower sentry looks like crap, comes out of the wrong spot
// TODO Flamethrower comes out back of your head

// TODO Add option that shuffles inventory for guns and nades in hotbar
// TODO Add zoom sound
// TODO Teleporters
// TODO Player spawners for teams
// TODO Teams!

// TODO Bullet casing arc isn't quite right, should go back when you look up
// TODO getDeathSound for Sentry

// SDK Guns
@SuppressWarnings({ "rawtypes", "unchecked" })
public class mod_SdkGuns extends SdkBaseModMp
{
    public static Block blockNuke;
    public static Block blockSentry;
    public static Block blockLighter;
    public static int blockLighterSideIndexInTexture;
    public static Block blockOil;
    public static int blockOilLineIndexInTexture;
    public static Block blockCannon;
    
	public static final Item itemBulletCasing = new Item(2500).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasing.png")).setItemName("bulletCasing");
    public static final Item itemBulletLight = new Item(2501).setMaxStackSize(32).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet9mm.png")).setItemName("bullet9mm");
    public static final Item itemBulletMedium = new Item(2502).setMaxStackSize(8).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet357.png")).setItemName("bullet357");
    public static final Item itemBulletShell = new Item(2503).setMaxStackSize(8).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletShell.png")).setItemName("bulletShell");
    public static final Item itemGunAk47 = new SdkItemGunAk47(2504).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunAk47.png")).setItemName("gunAk47");
    public static final Item itemGunMp5 = new SdkItemGunMp5(2505).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunMp5.png")).setItemName("gunMp5");
    public static final Item itemGunShotgun = new SdkItemGunShotgun(2506).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunShotgun.png")).setItemName("gunShotgun");
    public static final Item itemGunDeagle = new SdkItemGunDeagle(2507).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunDeagle.png")).setItemName("gunDeagle");
    public static final Item itemGrenade = new SdkItemGrenade(2508).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenade.png")).setItemName("grenade");
    public static final Item itemMetalParts = new Item(2514).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemMetalParts.png")).setItemName("metalParts");
    public static final Item itemBulletRocket = new Item(2515).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocket.png")).setItemName("bulletRocket");
    public static final Item itemGunRocketLauncher = new SdkItemGunRocketLauncher(2516).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncher.png")).setItemName("gunRocketLauncher");
    public static final Item itemBulletRocketLaser = new Item(2517).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocketLaser.png")).setItemName("bulletRocketLaser");
    public static final Item itemGunRocketLauncherLaser = new SdkItemGunRocketLauncherLaser(2518).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncherLaser.png")).setItemName("gunRocketLauncherLaser");
    public static final Item itemBulletHeavy = new Item(2519).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet50Cal.png")).setItemName("bullet50Cal");
    public static final Item itemGunSniper = new SdkItemGunSniper(2520).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSniper.png")).setItemName("gunSniper");
    public static final Item itemGrenadeStun = new SdkItemGrenadeStun(2522).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeStun.png")).setItemName("grenadeStun");
    public static final Item itemGrenadeSmoke = new SdkItemGrenadeSmoke(2524).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSmoke.png")).setItemName("grenadeSmoke");
    public static final Item itemBulletCasingShell = new Item(2525).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasingShell.png")).setItemName("bulletCasingShell");
    public static final Item itemOil = new SdkItemOil(2526).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemOil.png")).setItemName("itemOil");
    public static final Item itemGunFlamethrower = new SdkItemGunFlamethrower(2527).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunFlamethrower.png")).setItemName("gunFlamethrower");
    public static final Item itemGrenadeSticky = new SdkItemGrenadeSticky(2530).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSticky.png")).setItemName("grenadeSticky");
    public static final Item itemGunSg552 = new SdkItemGunSg552(2531).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSg552.png")).setItemName("gunSg552");
    public static final Item itemGunMinigun = new SdkItemGunMinigun(2532).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunMinigun.png")).setItemName("gunMinigun");
    public static final Item itemGunLaser = new SdkItemGunLaser(2535).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunLaser.png")).setItemName("gunLaser");
    public static final Item itemGunM4 = new SdkItemGunM4(2536).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunM4.png")).setItemName("gunM4");
    public static final Item itemGrenadeIncendiary = new SdkItemGrenadeIncendiary(2537).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeIncendiary.png")).setItemName("grenadeIncendiary");
    public static final Item itemGrenadeIncendiaryLit = new SdkItemGrenadeIncendiary(2554).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeIncendiaryLit.png")).setItemName("grenadeIncendiaryLit");

    public static final Item itemBarrelLong = new Item(2538).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelLong.png")).setItemName("itemBarrelLong");
    public static final Item itemBarrelShort = new Item(2539).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelShort.png")).setItemName("itemBarrelShort");
    public static final Item itemBarrelFat = new Item(2540).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelFat.png")).setItemName("itemBarrelFat");
    public static final Item itemBarrelShotgun = new Item(2541).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelShotgun.png")).setItemName("itemBarrelShotgun");
    public static final Item itemBarrelMinigun = new Item(2542).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelMinigun.png")).setItemName("itemBarrelMinigun");
    public static final Item itemGripWood = new Item(2543).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGripWood.png")).setItemName("itemGripWood");
    public static final Item itemGripMetal = new Item(2544).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGripMetal.png")).setItemName("itemGripMetal");
    public static final Item itemHandleMinigun = new Item(2545).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemHandleMinigun.png")).setItemName("itemHandleMinigun");
    public static final Item itemStockWood = new Item(2546).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemStockWood.png")).setItemName("itemStockWood");
    public static final Item itemStockMetal = new Item(2547).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemStockMetal.png")).setItemName("itemStockMetal");
    public static final Item itemReceiverMetal = new Item(2548).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemReceiverMetal.png")).setItemName("itemReceiverMetal");
    public static final Item itemReceiverDiamond = new Item(2549).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemReceiverDiamond.png")).setItemName("itemReceiverDiamond");
    public static final Item itemMagazine = new Item(2550).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemMagazine.png")).setItemName("itemMagazine");
    public static final Item itemScope = new Item(2551).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemScope.png")).setItemName("itemScope");

    public static final Item itemAtv = new SdkItemAtv(2552).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemAtv.png")).setItemName("itemAtv");
    public static final Item itemAtvBody = new Item(2553).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemAtvBody.png")).setItemName("itemAtvBody");
    public static Item itemAtvWheel;
    public static boolean hasPlanesMod = false;
    public static final Item itemWrench = new Item(2555).setMaxStackSize(1).setMaxDamage(15).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemWrench.png")).setItemName("itemWrench");
    
    public static final Item itemSentry = new SdkItemSentry(2556).setMaxStackSize(1).setMaxDamage(0).setHasSubtypes(true).setItemName("itemSentry");

    // Sentry classes and textures
    public static Class[] sentryEntityClasses = { SdkEntitySentryAk47.class, SdkEntitySentryMp5.class, SdkEntitySentryShotgun.class,
    	SdkEntitySentryDeagle.class, SdkEntitySentryRocketLauncher.class, SdkEntitySentryRocketLauncherLaser.class, SdkEntitySentrySniper.class,
    	SdkEntitySentryFlamethrower.class, SdkEntitySentrySg552.class, SdkEntitySentryMinigun.class, SdkEntitySentryLaser.class,
    	SdkEntitySentryM4.class };
    public static int[] sentryTextureIndices = {
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryAk47.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryMp5.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryShotgun.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryDeagle.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryRocketLauncher.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryRocketLauncherLaser.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentrySniper.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryFlamethrower.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentrySg552.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryMinigun.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryLaser.png"),
    	ModLoader.addOverride("/gui/items.png", "/sdk/blockSentryM4.png")
    };
    public static String[] sentryNames = {
    	"AK47", "MP5", "Shotgun", "Desert Eagle", "Rocket Launcher", "Laser-Guided Rocket Launcher", "Sniper Rifle", "Flamethrower", "SG552",
    	"Minigun", "Laser", "M4"
    };
    
    // Reload
    public static Map<EntityPlayer, Integer> reloadTimes = new HashMap<EntityPlayer, Integer>();
    
    // Recoil
    public static final double RECOIL_FIX_FACTOR = 0.1F;
    public static final double MIN_RECOIL_FIX = 0.5F;
    public static double currentRecoilV = 0F;
    public static double currentRecoilH = 0F;

    // Zoom
    public static final float DEFAULT_ZOOM = 1.0F;
    public static final float MAX_ZOOM_SNIPER = 0.125F;
    public static final float MAX_ZOOM_SG552 = 0.25F;
    private static final float ZOOM_INCREMENT = 0.075F;
    private static float currentZoom = DEFAULT_ZOOM;
    private static int lastZoomSlot = 0;
    private static boolean zoomEnabled = false;
    private static float lastZoom = currentZoom;
    private static boolean sniperZoomedIn = false;

	// Flash
    public static Map<EntityLiving, Pair<Integer, Float>> flashTimes = new HashMap<EntityLiving, Pair<Integer, Float>>();
    
    // Properties
    public static boolean guns = true;
    public static boolean bulletsDestroyGlass = true;
    public static boolean showAmmoBar = true;
    public static boolean muzzleFlash = false;
    public static boolean grenades = true;
    public static boolean explosionsDestroyBlocks = true;
    public static boolean laserSetsFireToBlocks = true;
    public static boolean nuke = true;
    public static float nukeBlastDiameter = 8;
    public static int nukeFuse = 80;
    public static boolean oil = true;
    public static boolean lighter = true;
    public static boolean cannon = true;
    public static boolean sentries = true;
    public static boolean sentriesKillAnimals = false;
    public static boolean atv = true;
    public static boolean ammoRestrictions = true;
    public static boolean hardcore = false;
    public static boolean ammoCasings = true;
    public static int zoomKey = Keyboard.KEY_Z;
    public static int reloadKey = Keyboard.KEY_R;
    public static int atvInventoryKey = Keyboard.KEY_I;
    public static int atvFireKey = Keyboard.KEY_SPACE;
    public static int blockIdNuke = 110;
    public static int blockIdSentry = 111;
    public static int blockIdLighter = 112;
    public static int blockIdOil = 113;
    public static int blockIdCannon = 114;
    
    // Hotkeys
    public static boolean zoomKeyDown = false;
    public static boolean reloadKeyDown = false;
    public static boolean atvInventoryKeyDown = false;

	// For burst fire
	public static Map<Entity, SdkBurstShotEntry> burstShots = new HashMap<Entity, SdkBurstShotEntry>();
	
	// For gun speed
	private Method minecraft_clickMouse = null;
	private Field minecraft_aa = null;
	private Field minecraft_ticksRan = null;

    static
    {
    	loadProperties();
    }
    
    private static void loadProperties()
    {
    	Properties properties = new Properties();
    	try
    	{
    		String propertiesPath = mod_SdkGuns.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath();
    		propertiesPath = propertiesPath.substring(0, propertiesPath.lastIndexOf('/'));
    		propertiesPath = propertiesPath.substring(0, propertiesPath.lastIndexOf('/'));
    		propertiesPath += "/mod_SdkGuns.properties";
    		
    		try
        	{
	    		properties.load(new FileInputStream(propertiesPath));
	        }
	        catch (Exception ex)
	        {
				ModLoader.getLogger().throwing("mod_SdkGuns", "loadProperties", ex);
				ModLoader.ThrowException("mod_SdkGuns.properties not found in the %APPDATA%\\.minecraft folder.", ex);
				return;
	        }
        
    		String property;
    		
    		property = properties.getProperty("guns");
    		guns = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("bulletsDestroyGlass");
    		bulletsDestroyGlass = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("showAmmoBar");
    		showAmmoBar = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("muzzleFlash");
    		muzzleFlash = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("grenades");
    		grenades = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("explosionsDestroyBlocks");
    		explosionsDestroyBlocks = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("laserSetsFireToBlocks");
    		laserSetsFireToBlocks = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("nuke");
    		nuke = property.trim().equalsIgnoreCase("true");

    		property = properties.getProperty("nukeBlastDiameter");
    		nukeBlastDiameter = Float.parseFloat(property.trim());

    		property = properties.getProperty("nukeFuse");
    		nukeFuse = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("oil");
    		oil = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("lighter");
    		lighter = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("cannon");
    		cannon = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentries");
    		sentries = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentriesKillAnimals");
    		sentriesKillAnimals = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("atv");
    		atv = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoRestrictions");
    		ammoRestrictions = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("hardcore");
    		hardcore = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoCasings");
    		ammoCasings = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("zoomKey");
    		int tempZoomKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempZoomKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding zoom key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			zoomKey = tempZoomKey;
    		}
    		
    		property = properties.getProperty("reloadKey");
    		int tempReloadKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempReloadKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding reload key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			reloadKey = tempReloadKey;
    		}
    		
    		property = properties.getProperty("atvInventoryKey");
    		int tempAtvInventoryKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempAtvInventoryKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding ATV inventory key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			atvInventoryKey = tempAtvInventoryKey;
    		}
    		
    		property = properties.getProperty("atvFireKey");
    		int tempAtvFireKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempAtvFireKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding ATV fire key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			atvFireKey = tempAtvFireKey;
    		}
    		
    		property = properties.getProperty("blockIdNuke");
    		blockIdNuke = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdSentry");
    		blockIdSentry = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdLighter");
    		blockIdLighter = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdOil");
    		blockIdOil = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdCannon");
    		blockIdCannon = Integer.parseInt(property.trim());
        }
    	catch (URISyntaxException ex)
    	{
    		ModLoader.getLogger().throwing("mod_SdkGuns", "loadProperties", ex);
			SdkTools.ThrowException("An impossible error has occurred!", ex);
			return;
    	}
    	catch (Exception ex)
    	{
    		ModLoader.getLogger().throwing("mod_SdkGuns", "loadProperties", ex);
			SdkTools.ThrowException("mod_SdkGuns.properties is corrupt.", ex);
			return;
    	}
    }
	
	public mod_SdkGuns()
	{
		super();
		
		ModLoader.AddName(blockNuke, "Nuke");
		ModLoader.AddName(blockSentry, "Sentry");
		ModLoader.AddName(blockLighter, "Lighter");
		ModLoader.AddName(blockOil, "Oil");
		ModLoader.AddName(blockCannon, "Cannon");
	    
		ModLoader.AddName(itemBulletCasing, "Bullet Casing");
		ModLoader.AddName(itemBulletLight, "Light Bullet");
		ModLoader.AddName(itemBulletMedium, "Medium Bullet");
		ModLoader.AddName(itemBulletShell, "Shotgun Shell");
		ModLoader.AddName(itemGunAk47, "AK47");
		ModLoader.AddName(itemGunMp5, "MP5");
		ModLoader.AddName(itemGunShotgun, "Shotgun");
		ModLoader.AddName(itemGunDeagle, "Desert Eagle");
		ModLoader.AddName(itemGrenade, "Grenade");
		ModLoader.AddName(itemMetalParts, "Metal Parts");
		ModLoader.AddName(itemBulletRocket, "Rocket");
		ModLoader.AddName(itemGunRocketLauncher, "Rocket Launcher");
		ModLoader.AddName(itemBulletRocketLaser, "Laser-Guided Rocket");
		ModLoader.AddName(itemGunRocketLauncherLaser, "Laser-Guided Rocket Launcher");
		ModLoader.AddName(itemBulletHeavy, "Heavy Bullet");
		ModLoader.AddName(itemGunSniper, "Sniper Rifle");
		ModLoader.AddName(itemGrenadeStun, "Stun Grenade");
		ModLoader.AddName(itemGrenadeSmoke, "Smoke Grenade");
		ModLoader.AddName(itemBulletCasingShell, "Shell Casing");
		ModLoader.AddName(itemOil, "Oil");
		ModLoader.AddName(itemGunFlamethrower, "Flamethrower");
		ModLoader.AddName(itemGrenadeSticky, "Sticky Grenade");
		ModLoader.AddName(itemGunSg552, "SG552");
		ModLoader.AddName(itemGunMinigun, "Minigun");
		ModLoader.AddName(itemGunLaser, "Laser");
		ModLoader.AddName(itemGunM4, "M4");
		ModLoader.AddName(itemGrenadeIncendiary, "Molotov Cocktail");

		ModLoader.AddName(itemBarrelLong, "Long Barrel");
		ModLoader.AddName(itemBarrelShort, "Short Barrel");
		ModLoader.AddName(itemBarrelFat, "Fat Barrel");
		ModLoader.AddName(itemBarrelShotgun, "Shotgun Barrel");
		ModLoader.AddName(itemBarrelMinigun, "Minigun Barrel");
		ModLoader.AddName(itemGripWood, "Wooden Grip");
		ModLoader.AddName(itemGripMetal, "Metal Grip");
		ModLoader.AddName(itemHandleMinigun, "Minigun Handle");
		ModLoader.AddName(itemStockWood, "Wooden Stock");
		ModLoader.AddName(itemStockMetal, "Metal Stock");
		ModLoader.AddName(itemReceiverMetal, "Receiver");
		ModLoader.AddName(itemReceiverDiamond, "Redstone -> Laser Converter");
		ModLoader.AddName(itemMagazine, "Magazine");
		ModLoader.AddName(itemScope, "Scope");
		ModLoader.AddName(itemAtv, "ATV");
		ModLoader.AddName(itemAtvBody, "ATV Body");
		ModLoader.AddName(itemWrench, "Wrench");
		ModLoader.AddName(new ItemStack(itemSentry, 1, 0), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 0)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 1), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 1)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 2), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 2)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 3), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 3)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 4), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 4)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 5), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 5)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 6), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 6)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 7), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 7)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 8), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 8)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 9), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 9)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 10), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 10)));
		ModLoader.AddName(new ItemStack(itemSentry, 1, 11), itemSentry.getItemNameIS(new ItemStack(itemSentry, 1, 11)));
		
		if(!hasPlanesMod)
			ModLoader.AddName(itemAtvWheel, "ATV Wheel");
	    
	    // For showing ammo amount
	    itemBulletLight.setMaxDamage(0);
	    itemBulletMedium.setMaxDamage(0);
	    itemBulletShell.setMaxDamage(0);
	    itemBulletRocket.setMaxDamage(0);
	    itemBulletRocketLaser.setMaxDamage(0);
	    itemBulletHeavy.setMaxDamage(0);
	    Item.redstone.setMaxDamage(0);
		
		ModLoader.RegisterEntityID(SdkEntityBulletShot.class, "Shell", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasing.class, "Casing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasingShell.class, "ShellCasing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenade.class, "Grenade", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityNukePrimed.class, "Nuke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryAk47.class, "SentryAk47", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryDeagle.class, "SentryDeagle", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryMp5.class, "SentryMp5", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncher.class, "SentryRocketLauncher", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncherLaser.class, "SentryRocketLauncherLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryShotgun.class, "SentryShotgun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySniper.class, "SentrySniper", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocket.class, "Rocket", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocketLaser.class, "RocketLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeStun.class, "GrenadeStun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSmoke.class, "GrenadeSmoke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletFlame.class, "Flame", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryFlamethrower.class, "SentryFlamethrower", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSticky.class, "GrenadeSticky", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySg552.class, "SentrySg552", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletLaser.class, "Laser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryMinigun.class, "SentryMinigun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryLaser.class, "SentryLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeIncendiary.class, "GrenadeIncendiary", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryM4.class, "SentryM4", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityAtv.class, "ATV", ModLoader.getUniqueEntityId());
		
		ModLoaderMp.RegisterGUI(this, 14);
		
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletAk47.class, 100);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletCasing.class, 101);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletCasingShell.class, 102);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletDeagle.class, 103);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletFlame.class, 104);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletLaser.class, 105);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletM4.class, 106);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletMinigun.class, 107);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletMp5.class, 108);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletRocket.class, 109);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletRocketLaser.class, 110);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletSg552.class, 111);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletShot.class, 112);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityBulletSniper.class, 113);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityGrenade.class, 114);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityGrenadeIncendiary.class, 115);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityGrenadeSmoke.class, 116);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityGrenadeSticky.class, 117);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityGrenadeStun.class, 118);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityNukePrimed.class, 119);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryAk47.class, 120);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryDeagle.class, 121);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryFlamethrower.class, 122);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryLaser.class, 123);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryMinigun.class, 124);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryM4.class, 125);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryMp5.class, 126);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryRocketLauncher.class, 127);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryRocketLauncherLaser.class, 128);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentrySg552.class, 129);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentryShotgun.class, 130);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntitySentrySniper.class, 131);
		ModLoaderMp.RegisterNetClientHandlerEntity(SdkEntityAtv.class, 134);
	}
	
	@Override
	public GuiScreen HandleGUI(int inventoryType) {
		switch(inventoryType)
		{
			case 14:
				return new SdkGuiAtv(SdkTools.minecraft.thePlayer.inventory, new SdkEntityAtv(SdkTools.minecraft.theWorld));
			default:
				return null;
		}
	}
    
	@Override
    public void InitBlocks()
    {
    	blockNuke = (new SdkBlockNuke(blockIdNuke, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"))).setHardness(0.0F).setStepSound(Block.soundGrassFootstep).setBlockName("blockNuke");
        blockSentry = (new SdkBlockSentry(blockIdSentry, ModLoader.addOverride("/terrain.png", "/sdk/blockSentry.png"))).setBlockName("blockSentry");
        blockLighter = (new SdkBlockLighter(blockIdLighter, ModLoader.addOverride("/terrain.png", "/sdk/blockLighterTop.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("blockLighter");
        blockLighterSideIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockLighterSide.png");
        blockOil = (new SdkBlockOil(blockIdOil, ModLoader.addOverride("/terrain.png", "/sdk/blockOilJunction.png"), ModLoader.getUniqueBlockModelID(instance, false))).setHardness(-1F).setBlockName("blockOil");
        blockOilLineIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockOilLine.png");
        blockCannon = (new SdkBlockCannon(blockIdCannon, ModLoader.addOverride("/terrain.png", "/sdk/blockCannon.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("blockCannon");
		
		ModLoader.RegisterBlock(blockNuke);
		ModLoader.RegisterBlock(blockSentry);
		ModLoader.RegisterBlock(blockLighter);
		ModLoader.RegisterBlock(blockOil);
		ModLoader.RegisterBlock(blockCannon);

		setBurnRates();
        
        try
        {
        	Class planes;
			try
			{
				planes = Class.forName("mod_Planes");
			}
    		catch (ClassNotFoundException ex)
    		{
    			planes = Class.forName("net.minecraft.src.mod_Planes");
    		}
    		
	        Field planesWheel = planes.getDeclaredField("wheel");
	        itemAtvWheel = (Item)planesWheel.get(null);
	        hasPlanesMod = true;
        }
        catch (Exception ex) {
        	System.out.println("mod_Planes not found in mod_SdkGuns. Ignore this exception if you do not have it installed.");
        	itemAtvWheel = new Item(23004).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemAtvWheel.png")).setItemName("itemAtvWheel");
        }
    }

	public static void setBurnRates()
	{
		//SdkTools.setBurnRate(blockNuke.blockID, 15, 100);
		SdkTools.setBurnRate(blockOil.blockID, 30, 60);
	}
	
	@Override
	public String Version()
	{
		return "1.4_01v1";
	}
	
	@Override
	public void OnTickInGameTick(Minecraft minecraft)
	{
		// Reset things
		if(!minecraft.thePlayer.isEntityAlive())
		{
			currentZoom = DEFAULT_ZOOM;
			
			if(reloadTimes.containsKey(minecraft.thePlayer))
				reloadTimes.remove(minecraft.thePlayer);
			
			if(flashTimes.containsKey(minecraft.thePlayer))
				flashTimes.remove(minecraft.thePlayer);
			
			currentRecoilV = 0;
			currentRecoilH = 0;
		}

		// Handle recoil
		handleRecoil(minecraft);
	
		// Handle reload
		handleReload();
		
		// Handle flash
		handleFlash();
		
		// Handle zoom
		handleZoom(minecraft);
		
		// Handle burst fire
		handleBurstShots(minecraft.theWorld);
		
		// Handle zoom key
        if(minecraft.currentScreen == null && !Keyboard.isKeyDown(zoomKey) && zoomKeyDown)
        	toggleZoomEnabled();
        zoomKeyDown = Keyboard.isKeyDown(zoomKey);
		
		// Handle reload key
        if(minecraft.currentScreen == null && !Keyboard.isKeyDown(reloadKey) && reloadKeyDown)
    		handleReload(minecraft.theWorld, minecraft.thePlayer, false);
        reloadKeyDown = Keyboard.isKeyDown(reloadKey);
		
		// Handle ATV inventory key
        if(!Keyboard.isKeyDown(atvInventoryKey) && atvInventoryKeyDown)
    		handleInventoryAtvKey(minecraft, minecraft.thePlayer);
        atvInventoryKeyDown = Keyboard.isKeyDown(atvInventoryKey);
		
		// Handle ATV fire key
        if(minecraft.currentScreen == null && Keyboard.isKeyDown(atvFireKey))
    		handleAtvFireKey(minecraft, minecraft.thePlayer);
        
        // Handle left click
        handleGuns(minecraft);
	}

	private void handleInventoryAtvKey(Minecraft minecraft, EntityPlayer entityplayer) {
		if(!minecraft.isMultiplayerWorld())
		{
			if(minecraft.currentScreen instanceof SdkGuiAtv)
				minecraft.displayGuiScreen(null);
			else if(entityplayer.ridingEntity instanceof SdkEntityAtv)
				ModLoader.OpenGUI(entityplayer, new SdkGuiAtv(entityplayer.inventory, (SdkEntityAtv)entityplayer.ridingEntity));
		}
		else
			ModLoaderMp.SendKey(this, 0);
	}

	private void handleAtvFireKey(Minecraft minecraft, EntityPlayer entityplayer) {
		if(!minecraft.isMultiplayerWorld())
		{
			if(entityplayer.ridingEntity instanceof SdkEntityAtv)
				((SdkEntityAtv)entityplayer.ridingEntity).fireGuns();
		}
		else
			ModLoaderMp.SendKey(this, 1);
	}

	private void handleGuns(Minecraft minecraft) {
		// If in game and right clicking
		if(minecraft.currentScreen == null && Mouse.isButtonDown(1))
		{
			// Get current item
			ItemStack itemStack = minecraft.thePlayer.getCurrentEquippedItem();
			
			// If it's an item with custom use delay
			if(itemStack != null && itemStack.getItem() instanceof SdkItemCustomUseDelay)
			{
				// Get the custom use delay item
				SdkItemCustomUseDelay item = ((SdkItemCustomUseDelay)itemStack.getItem());
				
				// If the item is ready
				if(item.isUseable(minecraft.theWorld, itemStack))
				{
					// Invoke mouseClick
					try
					{
						if(minecraft_clickMouse == null || minecraft_aa == null || minecraft_ticksRan == null)
						{
							try
							{
								minecraft_clickMouse = Minecraft.class.getDeclaredMethod("a", new Class[] { int.class });
							}
							catch (NoSuchMethodException ex)
							{
								minecraft_clickMouse = Minecraft.class.getDeclaredMethod("clickMouse", new Class[] { int.class });
							}
							
							minecraft_clickMouse.setAccessible(true);
							
							try
							{
								minecraft_aa = Minecraft.class.getDeclaredField("ad");
							}
							catch (NoSuchFieldException ex)
							{
								minecraft_aa = Minecraft.class.getDeclaredField("field_6302_aa");
							}
							
							minecraft_aa.setAccessible(true);
							
							try
							{
								minecraft_ticksRan = Minecraft.class.getDeclaredField("S");
							}
							catch (NoSuchFieldException ex)
							{
								minecraft_ticksRan = Minecraft.class.getDeclaredField("ticksRan");
							}
							
							minecraft_ticksRan.setAccessible(true);
						}
						
						minecraft_clickMouse.invoke(minecraft, 1);
						minecraft_aa.setInt(minecraft, minecraft_ticksRan.getInt(minecraft));
					}
					catch (IllegalAccessException ex)
					{
						ModLoader.getLogger().throwing("mod_SdkGuns", "handleGuns", ex);
						SdkTools.ThrowException("An impossible error has occurred!", ex);
						return;
					}
					catch (InvocationTargetException ex)
					{
						ModLoader.getLogger().throwing("mod_SdkGuns", "handleGuns", ex);
						SdkTools.ThrowException("An impossible error has occurred!", ex);
						return;
					}
					catch (NoSuchFieldException ex)
					{
						ModLoader.getLogger().throwing("mod_SdkGuns", "handleGuns", ex);
						SdkTools.ThrowException("SDK, you forgot to update your obfuscated reflection!", ex);
						return;
					}
					catch (NoSuchMethodException ex)
					{
						ModLoader.getLogger().throwing("mod_SdkGuns", "handleGuns", ex);
						SdkTools.ThrowException("SDK, you forgot to update your obfuscated reflection!", ex);
						return;
					}
				}
			}
		}
	}
	
	@Override
	public void OnTickInGame(Minecraft minecraft)
	{
		super.OnTickInGame(minecraft);
		
        // Handle drawing
		renderScopeOverlay(minecraft);
		renderFlash(minecraft.thePlayer);
		renderAmmo(minecraft);
		
		// Handle arm swing restriction
		handleArmSwing(minecraft);
	}
	
	private void handleArmSwing(Minecraft minecraft) {
        if(minecraft.thePlayer != null && minecraft.thePlayer.inventory != null)
        {
			ItemStack itemStack = minecraft.thePlayer.inventory.getCurrentItem();
			if(itemStack != null && itemStack.getItem() instanceof SdkItemCustomUseDelay)
			{
				SdkItemCustomUseDelay item = ((SdkItemCustomUseDelay)itemStack.getItem());
				if(item.stopArmSwing)
					try {
						ModLoader.setPrivateValue(Minecraft.class, minecraft, "T", 2);
					} catch (NoSuchFieldException e) {
						try {
							ModLoader.setPrivateValue(Minecraft.class, minecraft, "field_6282_S", 2);
						} catch (NoSuchFieldException ex) {
							ModLoader.getLogger().throwing("mod_SdkGuns", "handleArmSwing", ex);
							SdkTools.ThrowException("SDK, you forgot to update your obfuscated reflection!", ex);
							return;
						}
					}
			}
        }
	}

	@Override
	public void OnMainMenu()
	{
		reset();
	}

	private void reset() {
		loadProperties();
		setHardcore();
		SetRecipes();
	}

	private void setHardcore()
    {
    	try
		{
    		Field[] fields = EnumCreatureType.class.getDeclaredFields();
			for(int i = 0; i < fields.length; i++)
				if(fields[i].getType() == int.class)
				{
					fields[i].setAccessible(true);
					
					Field modifiersField = Field.class.getDeclaredField("modifiers");
				    modifiersField.setAccessible(true);
				    modifiersField.setInt(fields[i], fields[i].getModifiers() & ~Modifier.FINAL);
					
				    int numMobs, numCreatures, numWaterCreatures;
				    if(hardcore)
				    {
				    	numMobs = 700;
				    	numCreatures = 15;
				    	numWaterCreatures = 50;
				    }
				    else
				    {
				    	numMobs = 70;
				    	numCreatures = 15;
				    	numWaterCreatures = 5;
				    }
				    
				    Calendar calendar = Calendar.getInstance();
				    if(calendar.get(Calendar.MONTH) == Calendar.APRIL && calendar.get(Calendar.DAY_OF_MONTH) == 1)
				    	numCreatures = 200;
				    
				    fields[i].set(EnumCreatureType.monster, numMobs);
				    fields[i].set(EnumCreatureType.creature, numCreatures);
				    fields[i].set(EnumCreatureType.waterCreature, numWaterCreatures);
				}
		}
		catch (Exception ex)
		{
			ModLoader.getLogger().throwing("mod_SdkGuns", "setHardcore", ex);
			SdkTools.ThrowException("SDK, you forgot to update your obfuscated reflection!", ex);
			return;
		}
    }

	@Override
	public void SetRecipes() {
    	itemBulletLight.maxStackSize = 32;
    	itemBulletMedium.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemBulletShell.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemGrenade.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemBulletRocket.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletRocketLaser.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletHeavy.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemGrenadeStun.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSmoke.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSticky.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeIncendiary.maxStackSize = ammoRestrictions ? 4 : 64;
		
		SdkTools.setShapedRecipe(nuke, new ItemStack(blockNuke, 1), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Block.tnt, Character.valueOf('#'), Item.redstone
        });
		
		/*SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunAk47, 1), new Object[] {
            "X  ", "XX ", " X#", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunMp5, 1), new Object[] {
        	"X  ", "XX ", " XX", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunDeagle, 1), new Object[] {
        	"XXX", "  X", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunShotgun, 1), new Object[] {
        	"X  ", "#X ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncher, 1), new Object[] {
            "XXX", "XX ", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncherLaser, 1), new Object[] {
            "#XY", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), itemMetalParts, Character.valueOf('Y'), itemGunRocketLauncher
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSniper, 1), new Object[] {
            "X  ", " X#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunFlamethrower, 1), new Object[] {
			"X# ", "XX ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.flintAndSteel
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSg552, 1), new Object[] {
			"X  ", "XX#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunMinigun, 1), new Object[] {
			"XX ", "XXX", " XX", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunLaser, 1), new Object[] {
        	"#  ", "XX ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunM4, 1), new Object[] {
        	"X", Character.valueOf('X'), itemMetalParts
        });*/
		SdkTools.setShapedRecipe(guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasing
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletLight, ammoRestrictions ? 4 : itemBulletLight.maxStackSize), new Object[] {
            "X", "#", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletMedium, ammoRestrictions ? 4 : itemBulletMedium.maxStackSize), new Object[] {
            "X ", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletShell, ammoRestrictions ? 4 : itemBulletShell.maxStackSize), new Object[] {
            "X ", "#Y", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder, Character.valueOf('Y'), Item.paper
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletRocket, ammoRestrictions ? 1 : itemBulletRocket.maxStackSize), new Object[] {
            "###", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletRocketLaser, ammoRestrictions ? 1 : itemBulletRocketLaser.maxStackSize), new Object[] {
            "#Y#", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron,  Character.valueOf('Y'), Item.redstone
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletHeavy, itemBulletHeavy.maxStackSize), new Object[] {
            "XX", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasingShell
        });
		
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBarrelLong), new Object[] {
        	"XXX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBarrelShort), new Object[] {
        	"XX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBarrelFat), new Object[] {
        	"XXX", "XXX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemBarrelShotgun), new Object[] {
			new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong)
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemBarrelMinigun), new Object[] {
			new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong),
			new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong)
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGripWood), new Object[] {
        	"XX", " X", " X", Character.valueOf('X'), Block.wood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGripMetal), new Object[] {
        	"XX", " X", " X", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemHandleMinigun), new Object[] {
        	"XX", " X", "XX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemStockWood), new Object[] {
        	"XXX", " XX", Character.valueOf('X'), Block.wood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemStockMetal), new Object[] {
        	"XXX", " XX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemReceiverMetal), new Object[] {
        	Item.ingotIron, Item.ingotIron, itemMetalParts
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemReceiverDiamond), new Object[] {
        	"XX", "XX", Character.valueOf('X'), Item.diamond
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemMagazine), new Object[] {
        	"X", "X", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemScope), new Object[] {
        	"X#X", Character.valueOf('X'), Item.diamond, Character.valueOf('#'), Item.ingotIron
        });
		
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunAk47), new Object[] {
            "ABC", "DE ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockWood, 'D', itemMagazine, 'E', itemGripWood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunMp5), new Object[] {
            "ABC", "DE ", 'A', itemBarrelShort, 'B', itemReceiverMetal, 'C', itemStockMetal, 'D', itemMagazine, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunM4), new Object[] {
            "ABC", "DE ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockMetal, 'D', itemMagazine, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunFlamethrower), new Object[] {
            "AB", "DE", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'D', Item.bucketEmpty, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunSg552), new Object[] {
            " F ", "ABC", "DE ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockMetal, 'D', itemMagazine, 'E', itemGripMetal, 'F', itemScope
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunSniper), new Object[] {
            " F ", "ABC", " E ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockMetal, 'E', itemGripMetal, 'F', itemScope
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunLaser), new Object[] {
            "ABC", " E ", 'A', itemBarrelShort, 'B', itemReceiverDiamond, 'C', itemStockMetal, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunDeagle), new Object[] {
            "AB", " E", 'A', itemBarrelShort, 'B', itemReceiverMetal, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunShotgun), new Object[] {
            "ABC", " E ", 'A', itemBarrelShotgun, 'B', itemReceiverMetal, 'C', itemStockWood, 'E', itemGripWood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunRocketLauncher), new Object[] {
            "AAA", "BB ", 'A', itemBarrelFat, 'B', itemGripMetal
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemGunRocketLauncherLaser), new Object[] {
			new ItemStack(Item.diamond), new ItemStack(itemMetalParts), new ItemStack(itemGunRocketLauncher)
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunMinigun), new Object[] {
			" F ", "ABC", 'A', itemBarrelMinigun, 'B', itemReceiverMetal, 'C', itemStockMetal, 'F', itemHandleMinigun
        });
		
		SdkTools.setShapedRecipe(guns || sentries, new ItemStack(itemMetalParts, 1), new Object[] {
			"##", "##", Character.valueOf('#'), Item.ingotIron
		});
		SdkTools.setShapedRecipe(guns || sentries, new ItemStack(Item.ingotIron, 4), new Object[] {
			"#", Character.valueOf('#'), itemMetalParts
		});
		
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenade, 4), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenadeStun, 4), new Object[] {
            "X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.lightStoneDust
        });
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenadeSmoke, 4), new Object[] {
			"X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.flint
        });
		SdkTools.setShapelessRecipe(grenades, new ItemStack(itemGrenadeSticky), new Object[] {
            new ItemStack(itemGrenade), new ItemStack(Item.slimeBall)
        });
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenadeIncendiary, 4), new Object[] {
			" X ", "#Y#", " # ", Character.valueOf('X'), Item.paper, Character.valueOf('#'), Block.glass, Character.valueOf('Y'), itemOil
        });
		
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 0), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunAk47, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 1), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunMp5, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 2), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunShotgun, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 3), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunDeagle, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 4), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncher, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 5), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncherLaser, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 6), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSniper, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 7), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunFlamethrower, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 8), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSg552, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 9), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunMinigun, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 10), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunLaser, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 11), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunM4, Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(sentries && !guns, new ItemStack(itemSentry, 1, 0), new Object[] {
        	" X ", " X ", "X X", Character.valueOf('X'), itemMetalParts
        });
		
		// To allow conversion from blocks to items
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 0), new Object[] {
            new ItemStack(blockSentry, 1, 0)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 1), new Object[] {
            new ItemStack(blockSentry, 1, 1)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 2), new Object[] {
            new ItemStack(blockSentry, 1, 2)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 3), new Object[] {
            new ItemStack(blockSentry, 1, 3)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 4), new Object[] {
            new ItemStack(blockSentry, 1, 4)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 5), new Object[] {
            new ItemStack(blockSentry, 1, 5)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 6), new Object[] {
            new ItemStack(blockSentry, 1, 6)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 7), new Object[] {
            new ItemStack(blockSentry, 1, 7)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 8), new Object[] {
            new ItemStack(blockSentry, 1, 8)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 9), new Object[] {
            new ItemStack(blockSentry, 1, 9)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 10), new Object[] {
            new ItemStack(blockSentry, 1, 10)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 11), new Object[] {
            new ItemStack(blockSentry, 1, 11)
        });
		
		SdkTools.setShapedRecipe(lighter, new ItemStack(blockLighter, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Block.cobblestone, Character.valueOf('#'), Item.flintAndSteel
        });
	
		SdkTools.setShapedRecipe(oil, new ItemStack(itemOil, 1), new Object[] {
        	" X ", "X#X", " X ", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.bucketWater
        });
		
		SdkTools.setShapedRecipe(cannon, new ItemStack(blockCannon, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.redstone
        });

		SdkTools.setShapedRecipe(atv, new ItemStack(itemAtvBody), new Object[] {
        	"ZXZ", "XYX", "ZXZ", 'X', Item.ingotIron, 'Y', Block.stoneOvenIdle, 'Z', Item.redstone
        });
		SdkTools.setShapedRecipe(atv, new ItemStack(itemAtv), new Object[] {
        	" X ", "XYX", " X ", 'X', itemAtvWheel, 'Y', itemAtvBody
        });
		SdkTools.setShapedRecipe(atv, new ItemStack(itemWrench), new Object[] {
        	"X", "X", "X", 'X', Item.ingotIron
        });
		if(!hasPlanesMod)
			SdkTools.setShapedRecipe(atv, new ItemStack(itemAtvWheel), new Object[] {
	        	" X ", "XYX", " X ", 'X', Item.leather, 'Y', Item.ingotIron
	        });
	}

	@Override
    public void AddRenderer(Map map)
    {
    	map.put(SdkEntityBullet.class, new SdkRenderBullet());
		map.put(SdkEntityBulletShot.class, new SdkRenderBulletShot());
		map.put(SdkEntityBulletCasing.class, new SdkRenderBulletCasing());
		map.put(SdkEntityBulletCasingShell.class, new SdkRenderBulletCasingShell());
		map.put(SdkEntityNukePrimed.class, new SdkRenderNukePrimed());
		map.put(SdkEntitySentry.class, new SdkRenderSentry());
		map.put(SdkEntityBulletRocket.class, new SdkRenderBulletRocket());
		map.put(SdkEntityBulletRocketLaser.class, new SdkRenderBulletRocketLaser());
		map.put(SdkEntityBulletFlame.class, new SdkRenderBulletFlame());
		map.put(SdkEntityBulletLaser.class, new SdkRenderBulletLaser());

		map.put(SdkEntityAtv.class, new SdkRenderAtv());
    }
	
	@Override
	public void HandlePacket(Packet200ModLoader packet200ModLoader)
	{
		switch(packet200ModLoader.packetType)
		{
			case 1:
			{
				int[] dataInt = packet200ModLoader.dataInt;
				float[] dataFloat = packet200ModLoader.dataFloat;
				guns = dataInt[0] == 1;
				bulletsDestroyGlass = dataInt[1] == 1;
				grenades = dataInt[2] == 1;
				explosionsDestroyBlocks = dataInt[3] == 1;
				nuke = dataInt[4] == 1;
				nukeFuse = dataInt[5];
				oil = dataInt[6] == 1;
				lighter = dataInt[7] == 1;
				cannon = dataInt[8] == 1;
				sentries = dataInt[9] == 1;
				sentriesKillAnimals = dataInt[10] == 1;
				atv = dataInt[11] == 1;
				ammoRestrictions = dataInt[12] == 1;
				hardcore = dataInt[13] == 1;
				
				nukeBlastDiameter = dataFloat[0];
				
				SetRecipes();
				break;
			}
		}
	}

	private void handleZoom(Minecraft minecraft) {
		boolean zoomingIn = false;
		float maxZoom = DEFAULT_ZOOM;
		ItemStack itemStack = minecraft.thePlayer.inventory.getCurrentItem();
		if(minecraft.gameSettings != null && minecraft.thePlayer != null && minecraft.thePlayer.inventory != null)
		{
			if(itemStack == null
					|| (itemStack.getItem() != itemGunSniper && itemStack.getItem() != itemGunSg552)
					|| minecraft.thePlayer.inventory.currentItem != lastZoomSlot
					|| minecraft.gameSettings.thirdPersonView
					|| minecraft.currentScreen != null)
			{
				zoomEnabled = false;
			}
			lastZoomSlot = minecraft.thePlayer.inventory.currentItem;
			
			if(zoomEnabled && !minecraft.gameSettings.thirdPersonView)
			{
				if(itemStack.getItem() == itemGunSniper)
				{
					maxZoom = MAX_ZOOM_SNIPER;
				}
				else
				{
					maxZoom = MAX_ZOOM_SG552;
				}
				
				if(currentZoom > maxZoom)
				{
					zoomingIn = true;
				}
			}
		}
		
		if(zoomEnabled && zoomingIn)
			currentZoom = Math.max(maxZoom, currentZoom - ZOOM_INCREMENT);
		else if(!zoomEnabled && currentZoom < DEFAULT_ZOOM)
			currentZoom = Math.min(DEFAULT_ZOOM, currentZoom + ZOOM_INCREMENT);
		
		if(currentZoom == MAX_ZOOM_SNIPER && !sniperZoomedIn && itemStack != null && itemStack.getItem() == itemGunSniper)
		{
			sniperZoomedIn = true;
			
			Packet200ModLoader packet = new Packet200ModLoader();
			packet.packetType = 0;
			packet.dataInt = new int[] { 1 };
			ModLoaderMp.SendPacket(this, packet);
		}
		else if (currentZoom != MAX_ZOOM_SNIPER && sniperZoomedIn)
		{
			sniperZoomedIn = false;
			
			Packet200ModLoader packet = new Packet200ModLoader();
			packet.packetType = 0;
			packet.dataInt = new int[] { 0 };
			ModLoaderMp.SendPacket(this, packet);
		}
		
		if(currentZoom != lastZoom)
			minecraft.entityRenderer.func_21152_a(1 / currentZoom, 0, 0);
		
		lastZoom = currentZoom;
	}

	private void handleFlash() {
		Iterator<Map.Entry<EntityLiving,Pair<Integer, Float>>> it = flashTimes.entrySet().iterator();
		while (it.hasNext())
		{
		    Map.Entry<EntityLiving,Pair<Integer, Float>> entry = it.next();
		    
		    int n = entry.getValue().getLeft() - 1;
		    
		    if (n <= 0)
		    {
		    	entry.getKey().moveSpeed = entry.getValue().getRight();
		        it.remove();
		    }
		    else
		    {
		    	entry.setValue(new Pair<Integer, Float>(n, entry.getValue().getRight()));
		    }
		}
	}

	private void handleReload() {
		Iterator<Map.Entry<EntityPlayer,Integer>> it = reloadTimes.entrySet().iterator();
		while (it.hasNext()) {
		    Map.Entry<EntityPlayer,Integer> entry = it.next();
		    
		    int n = entry.getValue() - 1;
		    
		    if (n <= 0)
		        it.remove();
		    else
		    	entry.setValue(n);
		}
	}

	private void handleRecoil(Minecraft minecraft) {
		double recoilFixV = 0, lastRecoilV = currentRecoilV;
		if(minecraft.thePlayer != null && currentRecoilV > 0D)
		{
			recoilFixV = Math.min(Math.max(currentRecoilV * RECOIL_FIX_FACTOR, MIN_RECOIL_FIX), currentRecoilV);
			currentRecoilV -= recoilFixV;
			minecraft.thePlayer.rotationPitch += recoilFixV;
		}
		
		if(minecraft.thePlayer != null && Math.abs(currentRecoilH) > 0D)
		{
			double recoilFixH;
			if(currentRecoilH > 0D)
				recoilFixH = Math.min(Math.max(currentRecoilH * RECOIL_FIX_FACTOR / 2, MIN_RECOIL_FIX / 2), currentRecoilH);
			else
				recoilFixH = Math.max(Math.min(currentRecoilH * RECOIL_FIX_FACTOR / 2, -MIN_RECOIL_FIX / 2), currentRecoilH);
			
			if(recoilFixV != 0)
			{
				double synchedRecoilFix = recoilFixV / lastRecoilV * currentRecoilH;
				
				if(currentRecoilH > 0D)
					recoilFixH = Math.min(synchedRecoilFix, recoilFixH);
				else
					recoilFixH = Math.max(synchedRecoilFix, recoilFixH);
			}
			
			currentRecoilH -= recoilFixH;
			minecraft.thePlayer.rotationYaw -= recoilFixH;
		}
	}
	
	private void handleBurstShots(World world) {
		Iterator<Map.Entry<Entity,SdkBurstShotEntry>> it = burstShots.entrySet().iterator();
		while (it.hasNext()) {
		    Map.Entry<Entity,SdkBurstShotEntry> entry = it.next();
		    
		    SdkBurstShotEntry n = entry.getValue();
		    n.burstShots--;
		    
		    Entity entity = entry.getKey();
		    
		    Item gun = null;
		    if(entity instanceof EntityPlayer)
		    {
			    ItemStack itemStack = ((EntityPlayer)entity).getCurrentEquippedItem();
			    if(itemStack == n.itemStack)
			    	gun = itemStack.getItem();
		    }
		    else
		    	gun = entry.getValue().itemStack.getItem();
		    
		    boolean shotFired = false;
		    if(gun != null && ((SdkItemGun)gun).burstShots > 0)
		    	shotFired = ((SdkItemGun)gun).fireBullet(world, entity, n.itemStack, true, n.xOffset, n.yOffset, n.zOffset, n.rotationYawOffset, n.rotationPitchOffset);
		    
		    if (n.burstShots <= 0 || !shotFired)
		        it.remove();
		    else
		    	entry.setValue(n);
		}
	}
	
	private void renderAmmo(Minecraft minecraft)
	{
		if(showAmmoBar
				&& minecraft.playerController.shouldDrawHUD()
				&& minecraft.currentScreen == null
				&& (minecraft.gameSettings.thirdPersonView || currentZoom == DEFAULT_ZOOM))
		{
			ItemStack itemStack = minecraft.thePlayer.getCurrentEquippedItem();
		    if(itemStack != null)
		    {
		    	Item item = itemStack.getItem();
		    	if(item instanceof SdkItemGun)
		    	{
					int numStacks = getNumberInInventory(minecraft.thePlayer.inventory, ((SdkItemGun)item).requiredBullet.shiftedIndex);
		    		ScaledResolution scaledresolution = new ScaledResolution(minecraft.gameSettings, minecraft.displayWidth, minecraft.displayHeight);
		    		int width = scaledresolution.getScaledWidth();
		            int height = scaledresolution.getScaledHeight();
		            
		            // Draw number of clips
		            String numStacksString = ((Integer)(numStacks > 0 ? numStacks - 1 : 0)).toString();
		            int numStacksStringWidth = minecraft.fontRenderer.getStringWidth(numStacksString);
		            minecraft.fontRenderer.drawString(numStacksString, (width / 2 + 91) - numStacksStringWidth, height - 32 - 8, 0xFFFFFF);
		            
		            // Draw number of bullets
		            int ammoCount = mod_SdkGuns.getNumberInFirstStackInInventory(minecraft.thePlayer.inventory, ((SdkItemGun)item).requiredBullet.shiftedIndex);
	        		Tessellator tessellator = Tessellator.instance;
		            tessellator.startDrawingQuads();
		            if(item instanceof SdkItemGunFlamethrower)
		            {
		            	GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, minecraft.renderEngine.getTexture("/sdk/guiAmmoOil.png"));
			        	for(int q = ammoCount - 1; q >= 0; q--)
			        	{
			        		int x = (width / 2 + 91) - q - 1 - 14;
			        		int y = height - 32 - 9;
			        		
				            tessellator.addVertexWithUV(x, y + 9, -90D, 0.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 1, y + 9, -90D, 1.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 1, y, -90D, 1.0D, 0.0D);
				            tessellator.addVertexWithUV(x, y, -90D, 0.0D, 0.0D);
			        	}
		            }
		            else if(item instanceof SdkItemGunLaser)
		            {
		            	GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, minecraft.renderEngine.getTexture("/sdk/guiAmmoRedstone.png"));
			        	for(int q = ammoCount - 1; q >= 0; q--)
			        	{
			        		int x = (width / 2 + 91) - q - 1 - 14;
			        		int y = height - 32 - 9;
			        		
				            tessellator.addVertexWithUV(x, y + 9, -90D, 0.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 1, y + 9, -90D, 1.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 1, y, -90D, 1.0D, 0.0D);
				            tessellator.addVertexWithUV(x, y, -90D, 0.0D, 0.0D);
			        	}
		            }
		            else
		            {
			            GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, minecraft.renderEngine.getTexture("/sdk/guiAmmoBullet.png"));
			        	for(int q = ammoCount - 1; q >= 0; q--)
			        	{
			        		int x = (width / 2 + 91) - q * 2 - 3 - 14;
			        		int y = height - 32 - 9;
			        		
				            tessellator.addVertexWithUV(x, y + 9, -90D, 0.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 3, y + 9, -90D, 1.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 3, y, -90D, 1.0D, 0.0D);
				            tessellator.addVertexWithUV(x, y, -90D, 0.0D, 0.0D);
			        	}
		            }
		            tessellator.draw();
		    	}
		    }
		}
	}

	private void renderScopeOverlay(Minecraft minecraft)
	{
		if(!minecraft.gameSettings.thirdPersonView && currentZoom != DEFAULT_ZOOM && minecraft.currentScreen == null)
	        SdkTools.renderTextureOverlay("%blur%/sdk/miscScope.png", 1F);
	}

	private void renderFlash(EntityPlayer entityplayer)
	{
		if(getFlash(entityplayer) != 0F && SdkTools.minecraft.currentScreen == null)
			SdkTools.renderTextureOverlay("%blur%/sdk/miscFlash.png", getFlash(entityplayer));
	}
	
	private static void toggleZoomEnabled()
	{
		zoomEnabled = !zoomEnabled;
	}

	public static void handleReload(World world, EntityPlayer entityPlayer, boolean forcedReload)
	{
		if(!reloadTimes.containsKey(entityPlayer))
		{
			ItemStack itemStack = entityPlayer.getCurrentEquippedItem();
			if(itemStack != null && itemStack.getItem() instanceof SdkItemGun)
			{
				Item ammo = ((SdkItemGun)itemStack.getItem()).requiredBullet;
	
				int firstIndex = -1;
				int firstAmmoAmount = -1, secondAmmoAmount = -1;
				boolean hasReloaded = false;
				do
				{
					secondAmmoAmount = -1;
					
					InventoryPlayer inventory = entityPlayer.inventory;
					for(int j = firstIndex + 1; j < inventory.mainInventory.length; j++)
			            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == ammo.shiftedIndex)
			            {
			            	if(ammo.getMaxDamage() > 0)
			            	{
			            		int fullAmmoCount = ammo.getMaxDamage() + 1;
			            		
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = fullAmmoCount - inventory.mainInventory[j].getItemDamage();
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.getMaxDamage() > 0 && firstAmmoAmount == ammo.getMaxDamage() + 1)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = fullAmmoCount - inventory.mainInventory[j].getItemDamage();
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(fullAmmoCount - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			setItemDamage(inventory.mainInventory[firstIndex], fullAmmoCount - firstAmmoAmount);
			            			setItemDamage(inventory.mainInventory[j], fullAmmoCount - secondAmmoAmount);
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = new ItemStack(Item.bucketEmpty);
		            				
		            				break;
			            		}
			            	}
			            	else
			            	{
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = inventory.mainInventory[j].stackSize;
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.getMaxDamage() == 0 && firstAmmoAmount == ammo.maxStackSize)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = inventory.mainInventory[j].stackSize;
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(ammo.maxStackSize - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			inventory.mainInventory[firstIndex].stackSize = firstAmmoAmount;
		            				inventory.mainInventory[j].stackSize = secondAmmoAmount;
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = null;
		            				
		            				break;
			            		}
			            	}
			            	
			            	if(firstIndex == -1)
			            		firstIndex = j;
			            }
					
					// Break if no ammo found
					if(firstIndex == -1)
						break;
					
					// Reload and break if forced
					if(!hasReloaded && forcedReload)
					{
						reload(world, entityPlayer);
						break;
					}
					
					// Break if only one ammo stack found
					if(secondAmmoAmount == -1)
						break;
					
					// Break if full
					if(ammo.getMaxDamage() == 0 && firstAmmoAmount == ammo.maxStackSize)
						break;
					
					// Break if full
					if(ammo.getMaxDamage() > 0 && firstAmmoAmount == ammo.getMaxDamage() + 1)
						break;
				}
				while(true);
			}
		}
	}
	
	public static void setItemDamage(ItemStack itemStack, int itemDamage)
	{
		try
		{
			ModLoader.setPrivateValue(ItemStack.class, itemStack, 3, itemDamage);
		}
		catch (NoSuchFieldException ex)
		{
			ModLoader.getLogger().throwing("mod_SdkGuns", "setItemDamage", ex);
			SdkTools.ThrowException("SDK, you forgot to update your obfuscated reflection!", ex);
			return;
		}
	}
	
	public static void reload(World world, EntityPlayer entityplayer)
	{
		world.playSoundAtEntity(entityplayer, "sdk.reload", 1.0F, 1.0F / (entityplayer.rand.nextFloat() * 0.1F + 0.95F));
		reloadTimes.put(entityplayer, 40);
	}

	public static boolean getSniperZoomedIn()
	{
		return sniperZoomedIn;
	}
	
	public static float getFlash(EntityPlayer entityplayer)
	{
		if(flashTimes.containsKey(entityplayer))
    	{
    		return (float)flashTimes.get(entityplayer).getLeft() / SdkEntityGrenadeStun.MAX_FLASH_TIME_PLAYER;
    	}
		else
		{
			return 0.0F;
		}
	}
	
	public static int getNumberInFirstStackInInventory(InventoryPlayer inventory, int itemID)
    {
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == itemID)
            {
            	if(inventory.mainInventory[j].getItem().getMaxDamage() > 0)
            	{
            		return inventory.mainInventory[j].getItem().getMaxDamage() - inventory.mainInventory[j].getItemDamage() + 1;
            	}
            	else
            	{
            		return inventory.mainInventory[j].stackSize;
            	}
            }
        }

        return -1;
    }
	
	public static int getNumberInInventory(InventoryPlayer inventory, int i)
    {
		int num = 0;
		
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == i)
            {
            	num++;
            }
        }

        return num;
    }
	
	public static int getNumberInFirstStackInHotbar(InventoryPlayer inventory, int i)
    {
        for(int j = 0; j < 9; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == i)
            {
                return inventory.mainInventory[j].stackSize;
            }
        }

        return -1;
    }
	
	public static boolean playerInventoryEmpty(InventoryPlayer inventory)
    {
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null)
            {
            	return false;
            }
        }
        
        for(int j = 0; j < inventory.armorInventory.length; j++)
        {
            if(inventory.armorInventory[j] != null)
            {
            	return false;
            }
        }
        
        return true;
    }
	
	@Override
    public boolean RenderWorldBlock(RenderBlocks renderblocks, IBlockAccess iblockaccess, int i, int j, int k, Block block, int l)
	{
		try
		{
	        if(l == blockOil.getRenderType())
	        {
	            return renderBlockOil(renderblocks, block, i, j, k, iblockaccess);
	        }
		}
		catch (Exception ex)
		{
			ModLoader.getLogger().throwing("mod_SdkGuns", "RenderWorldBlock", ex);
			SdkTools.ThrowException("Error rendering custom blocks.", ex);
			return false;
		}
		
		return false;
	}
	
	public static boolean renderBlockOil(RenderBlocks renderblocks, Block block, int i, int j, int k, IBlockAccess blockAccess)
    {
        Tessellator tessellator = Tessellator.instance;
        int l = block.getBlockTextureFromSideAndMetadata(1, blockAccess.getBlockMetadata(i, j, k));
        if(renderblocks.overrideBlockTexture >= 0)
        {
            l = renderblocks.overrideBlockTexture;
        }
        float f = block.getBlockBrightness(blockAccess, i, j, k);
        tessellator.setColorOpaque_F(f, f, f);
        int i1 = (l & 0xf) << 4;
        int j1 = l & 0xf0;
        double d = (float)i1 / 256F;
        double d1 = ((float)i1 + 15.99F) / 256F;
        double d2 = (float)j1 / 256F;
        double d3 = ((float)j1 + 15.99F) / 256F;
        float f1 = 0.0F;
        float f2 = 0.03125F;
        boolean flag = blockAccess.getBlockId(i - 1, j, k) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j - 1, k) == blockOil.blockID;
        boolean flag1 = blockAccess.getBlockId(i + 1, j, k) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j - 1, k) == blockOil.blockID;
        boolean flag2 = blockAccess.getBlockId(i, j, k - 1) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j - 1, k - 1) == blockOil.blockID;
        boolean flag3 = blockAccess.getBlockId(i, j, k + 1) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j - 1, k + 1) == blockOil.blockID;
        if(!blockAccess.isBlockOpaqueCube(i, j + 1, k))
        {
            if(blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j + 1, k) == blockOil.blockID)
            {
                flag = true;
            }
            if(blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j + 1, k) == blockOil.blockID)
            {
                flag1 = true;
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j + 1, k - 1) == blockOil.blockID)
            {
                flag2 = true;
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j + 1, k + 1) == blockOil.blockID)
            {
                flag3 = true;
            }
        }
        float f3 = 0.3125F;
        float f4 = i + 0;
        float f5 = i + 1;
        float f6 = k + 0;
        float f7 = k + 1;
        byte byte0 = 0;
        if((flag || flag1) && !flag2 && !flag3)
        {
            byte0 = 1;
        }
        if((flag2 || flag3) && !flag1 && !flag)
        {
            byte0 = 2;
        }
        if(byte0 != 0)
        {
            l = blockOilLineIndexInTexture;
            i1 = (l & 0xf) << 4;
            j1 = l & 0xf0;

            d = (float)i1 / 256F;
            d1 = ((float)i1 + 15.99F) / 256F;
            d2 = (float)j1 / 256F;
            d3 = ((float)j1 + 15.99F) / 256F;
        }
        if(byte0 == 0)
        {
            if(flag1 || flag2 || flag3 || flag)
            {
                if(!flag)
                {
                    f4 += f3;
                }
                if(!flag)
                {
                    d += f3 / 16F;
                }
                if(!flag1)
                {
                    f5 -= f3;
                }
                if(!flag1)
                {
                    d1 -= f3 / 16F;
                }
                if(!flag2)
                {
                    f6 += f3;
                }
                if(!flag2)
                {
                    d2 += f3 / 16F;
                }
                if(!flag3)
                {
                    f7 -= f3;
                }
                if(!flag3)
                {
                    d3 -= f3 / 16F;
                }
            }
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d1, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d, d3);
        }
        if(byte0 == 1)
        {
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d1, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d, d3);
        }
        if(byte0 == 2)
        {
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d, d3);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d1, d2);
        }
        d = (float)(i1 + 16) / 256F;
        d1 = ((float)(i1 + 16) + 15.99F) / 256F;
        d2 = (float)j1 / 256F;
        d3 = ((float)j1 + 15.99F) / 256F;
        if(!blockAccess.isBlockOpaqueCube(i, j + 1, k))
        {
            if(blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j + 1, k) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 1) + f1, (float)(k + 1) + f1, d1, d2);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 0) - f1, (float)(k + 1) + f1, d, d2);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 0) - f1, (float)(k + 0) - f1, d, d3);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 1) + f1, (float)(k + 0) - f1, d1, d3);
            }
            if(blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j + 1, k) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 0) - f1, (float)(k + 1) + f1, d, d3);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 1) + f1, (float)(k + 1) + f1, d1, d3);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 1) + f1, (float)(k + 0) - f1, d1, d2);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 0) - f1, (float)(k + 0) - f1, d, d2);
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j + 1, k - 1) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 0) - f1, (float)k + f2, d, d3);
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 1) + f1, (float)k + f2, d1, d3);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 1) + f1, (float)k + f2, d1, d2);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 0) - f1, (float)k + f2, d, d2);
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j + 1, k + 1) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 1) + f1, (float)(k + 1) - f2, d1, d2);
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 0) - f1, (float)(k + 1) - f2, d, d2);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 0) - f1, (float)(k + 1) - f2, d, d3);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 1) + f1, (float)(k + 1) - f2, d1, d3);
            }
        }
        
        return true;
    }
}
